chiark / gitweb /
include test cases for python getsig replacement
[fdroidserver.git] / tests / run-tests
1 #!/bin/bash
2
3 set -e # quit script on error
4 set -x # show each command as it is executed
5
6 echo_header() {
7     echo "=============================================================================="
8     echo $1
9 }
10
11 copy_apks_into_repo() {
12     set +x
13     for f in `find $APKDIR -name '*.apk' | grep -F -v -e unaligned -e unsigned`; do
14         name=$(basename $(dirname `dirname $f`))
15         apk=`$aapt dump badging "$f" | sed -n "s,^package: name='\(.*\)' versionCode='\([0-9][0-9]*\)' .*,\1_\2.apk,p"`
16         test $f -nt repo/$apk && rm -f repo/$apk  # delete existing if $f is newer
17         if [ ! -e repo/$apk ] && [ ! -e archive/$apk ]; then
18             echo "$f --> repo/$apk"
19             ln $f $1/repo/$apk || \
20                 rsync -axv $f $1/repo/$apk # rsync if hard link is not possible
21         fi
22     done
23     set -x
24 }
25
26 # keep this as an old version to test the automatic parsing of build-tools
27 # verion numbers in `fdroid init`
28 create_fake_android_home() {
29     mkdir $1/tools
30     mkdir $1/platform-tools
31     mkdir $1/build-tools
32     mkdir $1/build-tools/19.0.2
33     touch $1/build-tools/19.0.2/aapt
34 }
35
36 create_test_dir() {
37     test -e $WORKSPACE/.testfiles || mkdir $WORKSPACE/.testfiles
38     mktemp --directory --tmpdir=$WORKSPACE/.testfiles
39 }
40
41 create_test_file() {
42     test -e $WORKSPACE/.testfiles || mkdir $WORKSPACE/.testfiles
43     mktemp --tmpdir=$WORKSPACE/.testfiles
44 }
45
46 #------------------------------------------------------------------------------#
47 # "main"
48
49 if [ $1 = "-h" ] || [ $1 = "--help" ]; then
50     set +x
51     echo "Usage: $0 '/path/to/folder/with/apks'"
52     exit 1
53 fi
54
55 if [ -z $ANDROID_HOME ]; then
56     echo "ANDROID_HOME must be set with the path to the Android SDK, i.e.: "
57     echo "  export ANDROID_HOME=/opt/android-sdk"
58     exit 1
59 fi
60
61 if [ -z $1 ]; then
62     APKDIR=`pwd`
63 else
64     APKDIR=$1
65 fi
66
67 if [ -z $WORKSPACE ]; then
68     WORKSPACE=`dirname $(pwd)`
69     echo "Setting Workspace to $WORKSPACE"
70 fi
71
72 # allow the location of the script to be overridden
73 if [ -z $fdroid ]; then
74     fdroid="$WORKSPACE/fdroid"
75 fi
76
77 # allow the location of aapt to be overridden
78 if [ -z $aapt ]; then
79     aapt=`ls -1 $ANDROID_HOME/build-tools/*/aapt | sort | tail -1`
80 fi
81
82 # allow the location of python to be overridden
83 if [ -z $python ]; then
84     python=python2
85 fi
86
87
88 #------------------------------------------------------------------------------#
89 echo_header "run commit hooks"
90
91 cd $WORKSPACE
92 ./hooks/pre-commit
93
94
95 #------------------------------------------------------------------------------#
96 echo_header "test python getsig replacement"
97
98 cd $WORKSPACE/tests/getsig
99 ./make.sh
100 cd $WORKSPACE/tests
101 ./update.TestCase
102
103
104 #------------------------------------------------------------------------------#
105 echo_header "create a source tarball and use that to build a repo"
106
107 cd $WORKSPACE
108 $python setup.py sdist
109
110 REPOROOT=`create_test_dir`
111 cd $REPOROOT
112 tar xzf `ls -1 $WORKSPACE/dist/fdroidserver-*.tar.gz | sort -n | tail -1`
113 cd $REPOROOT
114 ./fdroidserver-*/fdroid init
115 copy_apks_into_repo $REPOROOT
116 ./fdroidserver-*/fdroid update --create-metadata
117
118
119 #------------------------------------------------------------------------------#
120 echo_header "test config checks of local_copy_dir"
121
122 REPOROOT=`create_test_dir`
123 cd $REPOROOT
124 $fdroid init
125 $fdroid update --create-metadata
126 $fdroid server update --local-copy-dir=/tmp/fdroid
127
128 # now test the errors work
129 set +e
130 $fdroid server update --local-copy-dir=thisisnotanabsolutepath
131 if [ $? -eq 0 ]; then
132     echo "This should have failed because thisisnotanabsolutepath is not an absolute path!"
133     exit 1
134 else
135     echo "testing absolute path checker passed"
136 fi
137 $fdroid server update --local-copy-dir=/tmp/IReallyDoubtThisPathExistsasdfasdf
138 if [ $? -eq 0 ]; then
139     echo "This should have failed because the path does not end with 'fdroid'!"
140     exit 1
141 else
142     echo "testing dirname exists checker passed"
143 fi
144 $fdroid server update --local-copy-dir=/tmp/IReallyDoubtThisPathExistsasdfasdf/fdroid
145 if [ $? -eq 0 ]; then
146     echo "This should have failed because the dirname path does not exist!"
147     exit 1
148 else
149     echo "testing dirname exists checker passed"
150 fi
151 set -e
152
153
154 #------------------------------------------------------------------------------#
155 echo_header "setup a new repo from scratch using ANDROID_HOME and do a local sync"
156
157 REPOROOT=`create_test_dir`
158 cd $REPOROOT
159 $fdroid init
160 copy_apks_into_repo $REPOROOT
161 $fdroid update --create-metadata
162 grep -F '<application id=' repo/index.xml
163
164 LOCALCOPYDIR=`create_test_dir`/fdroid
165 $fdroid server update --local-copy-dir=$LOCALCOPYDIR
166 NEWREPOROOT=`create_test_dir`
167 cd $NEWREPOROOT
168 $fdroid init
169 $fdroid server update --local-copy-dir=$LOCALCOPYDIR --sync-from-local-copy-dir
170
171
172 #------------------------------------------------------------------------------#
173 # check that --android-home fails when dir does not exist or is not a dir
174
175 REPOROOT=`create_test_dir`
176 KEYSTORE=$REPOROOT/keystore.jks
177 cd $REPOROOT
178 set +e
179 $fdroid init --keystore $KEYSTORE --android-home /opt/fakeandroidhome
180 if [ $? -eq 0 ]; then
181     echo "This should have failed because /opt/fakeandroidhome does not exist!"
182     exit 1
183 else
184     echo "testing android-home path checker passed"
185 fi
186 TESTFILE=`create_test_file`
187 $fdroid init --keystore $KEYSTORE --android-home $TESTFILE
188 if [ $? -eq 0 ]; then
189     echo "This should have failed because $TESTFILE is a file not a dir!"
190     exit 1
191 else
192     echo "testing android-home not-dir checker passed"
193 fi
194 set -e
195
196
197 #------------------------------------------------------------------------------#
198 echo_header "check that fake android home passes 'fdroid init'"
199
200 REPOROOT=`create_test_dir`
201 FAKE_ANDROID_HOME=`create_test_dir`
202 create_fake_android_home $FAKE_ANDROID_HOME
203 KEYSTORE=$REPOROOT/keystore.jks
204 cd $REPOROOT
205 $fdroid init --keystore $KEYSTORE --android-home $FAKE_ANDROID_HOME
206
207
208 #------------------------------------------------------------------------------#
209 echo_header "check that 'fdroid init' fails when build-tools cannot be found"
210
211 REPOROOT=`create_test_dir`
212 FAKE_ANDROID_HOME=`create_test_dir`
213 create_fake_android_home $FAKE_ANDROID_HOME
214 rm -f $FAKE_ANDROID_HOME/build-tools/*/aapt
215 KEYSTORE=$REPOROOT/keystore.jks
216 cd $REPOROOT
217 set +e
218 $fdroid init --keystore $KEYSTORE --android-home $FAKE_ANDROID_HOME
219 [ $? -eq 0 ] && exit 1
220 set -e
221
222
223 #------------------------------------------------------------------------------#
224 echo_header "check that --android-home overrides ANDROID_HOME"
225
226 REPOROOT=`create_test_dir`
227 FAKE_ANDROID_HOME=`create_test_dir`
228 create_fake_android_home $FAKE_ANDROID_HOME
229 KEYSTORE=$REPOROOT/keystore.jks
230 cd $REPOROOT
231 $fdroid init --keystore $KEYSTORE --android-home $FAKE_ANDROID_HOME
232 set +e
233 grep $FAKE_ANDROID_HOME $REPOROOT/config.py
234 if [ $? -ne 0 ]; then
235     echo "the value set in --android-home '$FAKE_ANDROID_HOME' should override ANDROID_HOME '$ANDROID_HOME'"
236     exit 1
237 fi
238 set -e
239
240
241 #------------------------------------------------------------------------------#
242 # In this case, ANDROID_HOME is set to a fake, non-working version that will
243 # be detected by fdroid as an Android SDK install.  It should use the path set
244 # by --android-home over the one in ANDROID_HOME, therefore if it uses the one
245 # in ANDROID_HOME, it won't work because it is a fake one.  Only
246 # --android-home provides a working one.
247 echo_header "setup a new repo from scratch with keystore and android-home set on cmd line"
248
249 REPOROOT=`create_test_dir`
250 KEYSTORE=$REPOROOT/keystore.jks
251 FAKE_ANDROID_HOME=`create_test_dir`
252 create_fake_android_home $FAKE_ANDROID_HOME
253 STORED_ANDROID_HOME=$ANDROID_HOME
254 unset ANDROID_HOME
255 echo "ANDROID_HOME: $ANDROID_HOME"
256 cd $REPOROOT
257 $fdroid init --keystore $KEYSTORE --android-home $STORED_ANDROID_HOME --no-prompt
258 test -e $KEYSTORE
259 copy_apks_into_repo $REPOROOT
260 $fdroid update --create-metadata
261 grep -F '<application id=' repo/index.xml
262 test -e repo/index.xml
263 test -e repo/index.jar
264 export ANDROID_HOME=$STORED_ANDROID_HOME
265
266
267 #------------------------------------------------------------------------------#
268 echo_header "setup new repo from scratch using ANDROID_HOME, putting APKs in repo first"
269
270 REPOROOT=`create_test_dir`
271 cd $REPOROOT
272 mkdir repo
273 copy_apks_into_repo $REPOROOT
274 $fdroid init
275 $fdroid update --create-metadata
276 grep -F '<application id=' repo/index.xml
277
278
279 #------------------------------------------------------------------------------#
280 echo_header "setup a new repo from scratch and generate a keystore"
281
282 REPOROOT=`create_test_dir`
283 KEYSTORE=$REPOROOT/keystore.jks
284 cd $REPOROOT
285 $fdroid init --keystore $KEYSTORE
286 test -e $KEYSTORE
287 copy_apks_into_repo $REPOROOT
288 $fdroid update --create-metadata
289 test -e repo/index.xml
290 test -e repo/index.jar
291 grep -F '<application id=' repo/index.xml
292
293
294 #------------------------------------------------------------------------------#
295 echo_header "setup a new repo from scratch, generate a keystore, then add APK and update"
296
297 REPOROOT=`create_test_dir`
298 KEYSTORE=$REPOROOT/keystore.jks
299 cd $REPOROOT
300 $fdroid init --keystore $KEYSTORE
301 test -e $KEYSTORE
302 copy_apks_into_repo $REPOROOT
303 $fdroid update --create-metadata
304 test -e repo/index.xml
305 test -e repo/index.jar
306 grep -F '<application id=' repo/index.xml
307 cp $WORKSPACE/tests/urzip.apk $REPOROOT/
308 $fdroid update --create-metadata
309 test -e repo/index.xml
310 test -e repo/index.jar
311 grep -F '<application id=' repo/index.xml
312
313
314 #------------------------------------------------------------------------------#
315 echo_header "setup a new repo from scratch with a HSM/smartcard"
316
317 REPOROOT=`create_test_dir`
318 cd $REPOROOT
319 $fdroid init --keystore NONE
320 test -e opensc-fdroid.cfg
321 test ! -e NONE
322
323 rm -rf $WORKSPACE/fdroidserver.egg-info/
324
325 echo SUCCESS